-- 定义插件的一些常量和全局变量
local XyInProgress, NewDKP, IsLeader, Xys, NoXyList,curItem,rollEndTime,rollData,isRolling
local XyItemCount = {}  -- 新增：用于记录物品许愿次数
XY_BUTTON_HEIGHT = 25;
Xy_SortOptions = { ["method"] = "", ["itemway"] = "" };
UnitPopupButtons["GET_XY"] = { text = "查询许愿", dist = 0 };
UnitPopupButtons["ADD_DKP"] = { text = "增加分数", dist = 0, nested = 1 };
UnitPopupButtons["Minus_DKP"] = { text = "扣除分数", dist = 0, nested = 1 };

-- 添加子菜单按钮
UnitPopupButtons["ADD_DKP_1"] = { text = "增加1分", dist = 0 };
UnitPopupButtons["ADD_DKP_2"] = { text = "增加2分", dist = 0 };
UnitPopupButtons["ADD_DKP_3"] = { text = "增加3分", dist = 0 };
UnitPopupButtons["ADD_DKP_4"] = { text = "增加4分", dist = 0 };
UnitPopupButtons["MINUS_DKP_1"] = { text = "扣除1分", dist = 0 };
UnitPopupButtons["MINUS_DKP_2"] = { text = "扣除2分", dist = 0 };
UnitPopupButtons["MINUS_DKP_3"] = { text = "扣除3分", dist = 0 };
UnitPopupButtons["MINUS_DKP_4"] = { text = "扣除4分", dist = 0 };

NewDKP = false

--新功能，roll点监控
function RollStart()
	rollData={}
	isRolling=true
	rollEndTime = GetTime()+tonumber(XyTrackerOptions.rollTime);
	SendChatMessage(curItem.."开始ROLL点，"..XyTrackerOptions.rollTime.."秒后自动结束", "RAID", this.language, nil)
end

function RollEnd()
	rollEndTime = GetTime()
	isRolling=false
	if getn(rollData)>0 then
		SendChatMessage(curItem.."ROLL点结束，胜利者为"..rollData[1]["name"].."点数为["..rollData[1]["roll"].."]", "RAID", this.language, nil)
	else
		SendChatMessage(curItem.."ROLL点结束，无人roll点", "RAID", this.language, nil)
	end
end

function RollMonitor_Clear()
	rollData={}
	RollMonitor_UpdateList()
	getglobal("RollMonitorFrame"):Hide();
end

-- 修改为记录多个玩家的发言
local raidMessages = {}  -- 用于存储所有玩家的发言记录

-- 添加颜色模式切换函数
function greenMode_OnClick()
    XyTrackerOptions.greenModeEnabled = this:GetChecked()
end

function blueMode_OnClick()
    XyTrackerOptions.blueModeEnabled = this:GetChecked()
end

function purpleMode_OnClick()
    XyTrackerOptions.purpleModeEnabled = this:GetChecked()
end

function autoMode_OnClick()
    if this:GetChecked() then
        XyTrackerOptions.XyOnlyMode = 1
    else
        XyTrackerOptions.XyOnlyMode = 0
    end
end

function autoAnnounce_OnClick()
    if this:GetChecked() then
        XyTrackerOptions.AutoAnnounce = true
    else
        XyTrackerOptions.AutoAnnounce = false
    end
end

-- 调用默认DKP
function printDefaultDKP()
    getglobal("allDKPFrameTXT"):SetText(DefaultDKP);
end
-- 更新默认DKP
function NEWDefaultDKP()
    DefaultDKP = getglobal("allDKPFrameTXT"):GetNumber();
    NewDKP = true
    XyTracker_OnRefreshButtonClick()
    XyTracker_UpdateList() -- 更新DKP列表
    SendChatMessage("通知：当前默认DKP为每人" .. DefaultDKP .. "分，分数已初始化", "RAID", this.language, nil)
end
-- 检查列表中是否包含指定元素
function contain(v, l)
    if not l then
        return false
    end
    local n = getn(l)
    if n > 0 then
        for i = 1, n do
            local lv = l[i]
            if v == lv then
                return true
            end
        end
    end
    return false
end
-- 插件加载时的初始化函数
function XyTracker_OnLoad()
    -- 在单位弹出菜单中添加"查询许愿"和"修改分数"按钮
    if UnitPopupMenus["PARTY"] then
        if not contain("GET_XY", UnitPopupMenus["PARTY"]) then
            table.insert(UnitPopupMenus["PARTY"], "GET_XY")
            end
        if not contain("ADD_DKP", UnitPopupMenus["ADD_DKP"]) then
            table.insert(UnitPopupMenus["PARTY"], "ADD_DKP")
            end
        if not contain("Minus_DKP", UnitPopupMenus["Minus_DKP"]) then
            table.insert(UnitPopupMenus["PARTY"], "Minus_DKP")
        end
    end
    -- 增加聊天框右键快捷功能
    if UnitPopupMenus["RAID"] then
        if not contain("GET_XY", UnitPopupMenus["RAID"]) then
            table.insert(UnitPopupMenus["RAID"], "GET_XY")
        end
        if not contain("ADD_DKP", UnitPopupMenus["RAID"]) then
            table.insert(UnitPopupMenus["RAID"], "ADD_DKP")
        end
        if not contain("Minus_DKP", UnitPopupMenus["RAID"]) then
            table.insert(UnitPopupMenus["RAID"], "Minus_DKP")
        end
    end
    if UnitPopupMenus["PLAYER"] then
        if not contain("GET_XY", UnitPopupMenus["PLAYER"]) then
            table.insert(UnitPopupMenus["PLAYER"], "GET_XY")
        end
        if not contain("ADD_DKP", UnitPopupMenus["PLAYER"]) then
            table.insert(UnitPopupMenus["PLAYER"], "ADD_DKP")
        end
        if not contain("Minus_DKP", UnitPopupMenus["PLAYER"]) then
            table.insert(UnitPopupMenus["PLAYER"], "Minus_DKP")
        end
    end    
    if UnitPopupMenus["FRIEND"] then
        if not contain("GET_XY", UnitPopupMenus["FRIEND"]) then
            table.insert(UnitPopupMenus["FRIEND"], "GET_XY")
        end
        if not contain("ADD_DKP", UnitPopupMenus["FRIEND"]) then
            table.insert(UnitPopupMenus["FRIEND"], "ADD_DKP")
        end
        if not contain("Minus_DKP", UnitPopupMenus["FRIEND"]) then
            table.insert(UnitPopupMenus["FRIEND"], "Minus_DKP")
        end
    end 

    -- 设置命令行指令
    SlashCmdList["XYTRACKER"] = XyTracker_OnSlashCommand
    SLASH_XYTRACKER1 = "/xyt"
    SLASH_XYTRACKER2 = "/Xytrack"
    -- 注册事件监听
    this:RegisterEvent("CHAT_MSG_SYSTEM")
    this:RegisterEvent("CHAT_MSG_PARTY")
    this:RegisterEvent("CHAT_MSG_RAID")
    this:RegisterEvent("CHAT_MSG_RAID_LEADER")
    this:RegisterEvent("CHAT_MSG_RAID_WARNING")
    this:RegisterEvent("CHAT_MSG_ADDON")
    this:RegisterEvent("CHAT_MSG_WHISPER")
    this:RegisterEvent("CHAT_MSG_LOOT")
    this:RegisterForDrag("LeftButton");
    -- 设置界面样式
    this:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
    this:SetBackdropBorderColor(RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b);
    -- 备份原始单位弹出窗口点击处理函数
    ori_unitpopup1 = UnitPopup_OnClick;
    -- 替换单位弹出窗口点击处理函数
    UnitPopup_OnClick = ple_unitpopup1;
    -- 初始化变量
	if not XyTrackerOptions then
		XyTrackerOptions={
			AutoAnnounce = false,
			greenModeEnabled = false,
			blueModeEnabled = false,
			purpleModeEnabled = true,  -- 默认紫色开启
			XyOnlyMode = 0,
			rollTime = 60,
			autoMinDkp = false
		}
	end
    if XyArray == nil then
        XyArray = {}
    end
    XyInProgress = false
    NoXyList = ""
    Xys = 0
    local autoModeButtons = getglobal("autoModeButtons");
    autoModeButtons:SetChecked(XyTrackerOptions.XyOnlyMode);
    getglobal("autoAnnounceButton"):SetChecked(XyTrackerOptions.AutoAnnounce); -- 设置勾选框状态
    XyTracker_UpdateList()
    SendAddonMessage("XY_SYNC_NEW", "", "RAID")
    -- 加载存储的数据
    if XyTrackerDB then
        for name, data in pairs(XyTrackerDB) do
            local info = getXyInfo(name)
            if info then
                info.dkp = data.dkp
            end
        end
    end

    -- 添加子菜单
    if not UnitPopupMenus["ADD_DKP"] then
        UnitPopupMenus["ADD_DKP"] = {
            "ADD_DKP_1",
            "ADD_DKP_2", 
            "ADD_DKP_3",
            "ADD_DKP_4"
        };
    end
    
    if not UnitPopupMenus["Minus_DKP"] then
        UnitPopupMenus["Minus_DKP"] = {
            "MINUS_DKP_1",
            "MINUS_DKP_2",
            "MINUS_DKP_3", 
            "MINUS_DKP_4"
        };
    end
	
	--增强CML拾取大师
-- 	if CML_Vars and CML_Vars.Enabled then
-- 		if (XTY_ORGGROUPLOOTDROPDOWN == nil) then
-- 			XTY_ORGGROUPLOOTDROPDOWN = CML_InitDropDown;
-- 		end
-- 		UIDropDownMenu_Initialize(GroupLootDropDown, XYT_InitDropDown, "MENU");
-- 	else
-- 		if (XTY_ORGGROUPLOOTDROPDOWN == nil) then
-- 			XTY_ORGGROUPLOOTDROPDOWN = GroupLootDropDown_Initialize;
-- 		end
-- 		UIDropDownMenu_Initialize(GroupLootDropDown, XYT_InitDropDown, "MENU");
-- 	end
end

function XYT_InitDropDown()
	XTY_ORGGROUPLOOTDROPDOWN();
	if UIDROPDOWNMENU_MENU_LEVEL == 1 then
		UIDropDownMenu_AddButton {
			text = "许愿插件增强功能",
			notCheckable = 1,
			isTitle = 1,
		}
		UIDropDownMenu_AddButton {
			text = "出分",
			func = xytShowDKP,
		}
		UIDropDownMenu_AddButton {
			text = "ROLL",
			func = xytRoll,
		}
	end
end

function xytShowDKP()
	local item =ITEM_QUALITY_COLORS[LootFrame.selectedQuality].hex .. LootFrame.selectedItemName .. FONT_COLOR_CODE_CLOSE;
	SendChatMessage(item.."要的出分", "RAID", this.language, nil)
end

function xytRoll()
	curItem =ITEM_QUALITY_COLORS[LootFrame.selectedQuality].hex .. LootFrame.selectedItemName .. FONT_COLOR_CODE_CLOSE;
	getglobal("RollMonitorFrameTitle"):SetText("ROLL点监控:"..curItem);
	getglobal("xytRollTime"):SetText(XyTrackerOptions.rollTime);
	getglobal("RollMonitorFrame"):Show();
end


-- 替换后的单位弹出窗口点击处理函数
function ple_unitpopup1()
    local dropdownFrame = getglobal(UIDROPDOWNMENU_INIT_MENU);
    local button = this.value;
    local unit = dropdownFrame.unit;
    local name = dropdownFrame.name;
    local server = dropdownFrame.server;

    if (button == "GET_XY") then
        XyQuery(name);
    -- 处理增加分数的子菜单
    elseif button == "ADD_DKP_1" then
        XyAddDkp(name, 1);
    elseif button == "ADD_DKP_2" then
        XyAddDkp(name, 2);
    elseif button == "ADD_DKP_3" then
        XyAddDkp(name, 3);
    elseif button == "ADD_DKP_4" then
        XyAddDkp(name, 4);
    -- 处理扣除分数的子菜单
    elseif button == "MINUS_DKP_1" then
        XyMinusDkp(name, 1);
    elseif button == "MINUS_DKP_2" then
        XyMinusDkp(name, 2);
    elseif button == "MINUS_DKP_3" then
        XyMinusDkp(name, 3);
    elseif button == "MINUS_DKP_4" then
        XyMinusDkp(name, 4);
    else
        return ori_unitpopup1();
    end
    
    PlaySound("UChatScrollButton");
end

-- 获取指定名字的许愿信息
function getXyInfo(name)
    local n = getn(XyArray)
    if n > 0 then
        for i = 1, n do
            local info = XyArray[i]
            if info["name"] == name then
                info["dkp"] = tonumber(info["dkp"]) or DefaultDKP  -- 确保 DKP 是数字
                return info
            end
        end
    end
    --如果是新加入的成员。初始化该成员信息并返回 by 无道暴君20250217
    local totalMembers = GetNumRaidMembers()
    if totalMembers then
        for i = 1, totalMembers do
            local player, rank, subgroup, level, class, fileName, zone, online = GetRaidRosterInfo(i);
            if name==player then
                local info = {}
                info["name"] = name
                info["class"] = class
                info["xy"] = "---未许愿---"
                info["dkp"] = DefaultDKP
                table.insert(XyArray, info)
                NoXyList = NoXyList .. name .. " "
                return info;
            end
        end
    end
    return nil
end

-- 新增更新roll点信息
function RollMonitor_UpdateList()
	FauxScrollFrame_Update(RollListScrollFrame, 10, 10, 25);
	table.sort(rollData, Xy_CompareRolls);
	for i = 1, 10 do
		if i > getn(rollData) then
			getglobal("RollFrameListButton" .. i):Hide();
		else
			local v = rollData[i]
			getglobal("RollFrameListButton" .. i .. "Name"):SetText(v["name"]);
			getglobal("RollFrameListButton" .. i .. "Class"):SetText(v["class"]);
			getglobal("RollFrameListButton" .. i .. "Xy"):SetText(v["xy"]);
			getglobal("RollFrameListButton" .. i .. "DKP"):SetText(v["dkp"]);
			getglobal("RollFrameListButton" .. i .. "Roll"):SetText(v["roll"]);
			getglobal("RollFrameListButton" .. i):Show();
		end
	end
end

function Xy_CompareRolls(a1,a2)
    local c1, c2 = a1["roll"], a2["roll"];
	return tonumber(c1) > tonumber(c2);
end

-- 更新许愿者列表
function XyTracker_UpdateList()
    NoXyList = ""
    Xys = 0
    local totalMembers = GetNumRaidMembers()
    if totalMembers and IsLeader then
        for i = 1, totalMembers do
            local name, rank, subgroup, level, class, fileName, zone, online = GetRaidRosterInfo(i);
            local info = getXyInfo(name);
            if info then
                if NewDKP then
                    info["dkp"] = DefaultDKP
                end
                if info["xy"] and info["xy"] ~= "---未许愿---" then
                    Xys = Xys + 1
                else
                    NoXyList = NoXyList .. name .. " "
                end
            else
                info = {}
                info["name"] = name
                info["class"] = class
                info["xy"] = "---未许愿---"
                info["dkp"] = DefaultDKP
                table.insert(XyArray, info)
                NoXyList = NoXyList .. name .. " "
            end
        end
        NewDKP = false
    end
    XyTrackerFrameStatusText:SetText(XyTracker_If(Xys == 0, "当前无人许愿", string.format("%d当前许愿人数", Xys)))
    FauxScrollFrame_Update(XyListScrollFrame, totalMembers, 15, 25);
    if getn(XyArray) > 0 then
        local offset = FauxScrollFrame_GetOffset(XyListScrollFrame);
        for i = 1, 15 do
            k = offset + i;
            if k > getn(XyArray) then
                getglobal("XyFrameListButton" .. i):Hide();
            else
                v = XyArray[k]
                getglobal("XyFrameListButton" .. i .. "Name"):SetText(v["name"]);
                getglobal("XyFrameListButton" .. i .. "Class"):SetText(v["class"]);
                getglobal("XyFrameListButton" .. i .. "Xy"):SetText(v["xy"]);
                getglobal("XyFrameListButton" .. i .. "DKP"):SetText(v["dkp"]);
                if IsLeader then
                    getglobal("XyFrameListButton" .. i .. "AddDkp"):Show();
                    getglobal("XyFrameListButton" .. i .. "MinusDkp"):Show();
                    getglobal("XyTrackerFrameBatchAddFrame"):Show();
                else
                    getglobal("XyFrameListButton" .. i .. "AddDkp"):Hide();
                    getglobal("XyFrameListButton" .. i .. "MinusDkp"):Hide();
                    getglobal("XyTrackerFrameBatchAddFrame"):Hide();
                end
                getglobal("XyFrameListButton" .. i):Show();
            end
        end
    else
        for i = 1, 15 do
            getglobal("XyFrameListButton" .. i):Hide();
        end
    end
end

--function XyTracker_Print(msg)
--    if DEFAULT_CHAT_FRAME then
--        DEFAULT_CHAT_FRAME:AddMessage(msg)
--    end
--end

function XyTracker_If(expr, a, b)
    if expr then
        return a
    else
        return b
    end
end
function XyTracker_OnSlashCommand(msg)
    if XyTrackerFrame:IsVisible() then
        XyTracker_HideXyWindow()
    else
        XyTracker_ShowXyWindow()
    end
end

function XyTracker_ShowXyWindow()
    if DefaultDKP == nil then
        DefaultDKP = 4
    end
    ShowUIPanel(XyTrackerFrame)
end

function XyTracker_HideXyWindow()
    HideUIPanel(XyTrackerFrame)
end

function XyButton_UpdatePosition()
    XyButtonFrame:SetPoint(
            "TOPLEFT",
            "Minimap",
            "TOPLEFT",
            54 - (78 * cos(200)),
            (78 * sin(200)) - 55
    );
end

-- 新增：检测聊天中的物品链接并通报许愿信息（非许愿阶段）
function CheckItemAndAnnounceWish(msg, sender)
    if XyInProgress or not XyTrackerOptions.AutoAnnounce then return end  -- 仅在非许愿阶段触发
    
    -- 提取消息中的所有物品链接
    for itemLink in string.gmatch(msg, "|Hitem:.-|h.-|h") do
        local itemName = ExtractItemName(itemLink)
        local wishPlayers = {}
        
        -- 遍历许愿列表，匹配有效许愿条目
        for i = 1, getn(XyArray) do
            local info = XyArray[i]
            local wishItem = ExtractItemName(info["xy"] or "")
            if wishItem == itemName 
                and info["xy"] ~= "---未许愿---" 
                and info["xy"] ~= "|cFF00FFFF已完成许愿|r" 
            then
                table.insert(wishPlayers, {name = info["name"], dkp = info["dkp"]})
            end
        end
        
        -- 生成通报内容
        if getn(wishPlayers) > 0 then
            local announcement = "★"..itemName.."★共"..getn(wishPlayers).."人许愿："
            for idx = 1, getn(wishPlayers) do
                local player = wishPlayers[idx]
                announcement = announcement .. player.name .. "（" .. player.dkp .. "分）"
                if idx < getn(wishPlayers) then
                    announcement = announcement .. "、"
                end
            end
            SendChatMessage(announcement, "RAID", nil, nil)
        end
    end
end

function XyTracker_OnEvent(event)
	if isRolling and GetTime() > rollEndTime then
		RollEnd()
	end
    if event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" then
        -- 检查消息是否为1-9的数字
        local number = tonumber(arg1)
		
        if number and number >= 1 and number <= 9 then
            -- 更新玩家发言记录
            raidMessages[arg2] = {
                message = number,
                timestamp = GetTime()
            }
        end
        XyTracker_OnSystemMessage()  -- 添加这行来处理系统消息
    end
    
    -- 检测物品获取
    if event == "CHAT_MSG_LOOT" and XyTrackerOptions.autoMinDkp then
        local player, itemLink = string.match(arg1, "(.+)获得了物品：(.+)。")
        if player and itemLink then    
            -- 检查该玩家是否在1分钟内发过言
            local currentTime = GetTime()
            local playerMessage = raidMessages[player]
            
            if not playerMessage then
            --    DEFAULT_CHAT_FRAME:AddMessage("未扣分原因: 玩家没有发言记录")
            elseif (currentTime - playerMessage.timestamp) > 60 then
            --    DEFAULT_CHAT_FRAME:AddMessage("未扣分原因: 玩家发言已超过1分钟")
            else
                local _, _, itemColor = string.find(itemLink, "|c(%x+)|H")
                local shouldDeduct = false
                
                if itemColor == "ffa335ee" and XyTrackerOptions.purpleModeEnabled then
                    shouldDeduct = true
                elseif itemColor == "ff0070dd" and XyTrackerOptions.blueModeEnabled then
                    shouldDeduct = true
                elseif itemColor == "ff1eff00" and XyTrackerOptions.greenModeEnabled then
                    shouldDeduct = true
                else
            --        DEFAULT_CHAT_FRAME:AddMessage("未扣分原因: 物品颜色不符合或对应颜色未启用")
                end
                
                    if shouldDeduct and IsLeader then  -- 额外添加 IsLeader 检查
                    local info = getXyInfo(player)
                    if info then
                        local number = playerMessage.message
                        
                        if info["xy"] == "|cFF00FFFF已完成许愿|r" then
                            -- 已完成许愿状态，直接扣分
                            info["dkp"] = tonumber(info["dkp"]) - number
                            SendChatMessage(player .. " 扣除" .. number .. "分，当前剩余分数：[" .. info["dkp"] .. "]", "RAID", this.language, nil)
                        elseif info["xy"] and info["xy"] ~= "---未许愿---" then
                            -- 有许愿内容时的处理
                            if number <= 4 then
                                info["dkp"] = tonumber(info["dkp"]) - number
                                SendChatMessage(player .. " 扣除" .. number .. "分，当前剩余分数：[" .. info["dkp"] .. "]", "RAID", this.language, nil)
                            elseif number == 5 then
                                info["xy"] = "|cFF00FFFF已完成许愿|r"
                                SendChatMessage(player .. " 已完成许愿，当前剩余分数：[" .. info["dkp"] .. "]", "RAID", this.language, nil)
                            else
                                info["xy"] = "|cFF00FFFF已完成许愿|r"
                                local deductPoints = number - 5
                                info["dkp"] = tonumber(info["dkp"]) - deductPoints
                                SendChatMessage(player .. " 已完成许愿，并扣除" .. deductPoints .. "分，当前剩余分数：[" .. info["dkp"] .. "]", "RAID", this.language, nil)
                            end
                        end
                        XyTracker_UpdateList()
                        syncXy()
                        -- 只清除获得物品玩家的发言记录
                        raidMessages[player] = nil
                    end
                end
            end
        end
    end
    
        -- 新增：团队聊天中检测物品链接并通报（非许愿阶段）
    if (event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID_WARNING") then
        CheckItemAndAnnounceWish(arg1, arg2)
    end
    
    --查询许愿
    if event == "CHAT_MSG_WHISPER" then
        if arg1 == "cxxy" then
            XyQuery(arg2)
        end
    end
    --团长点开始许愿,所有团员的禁用团长权限,离开队伍后恢复
    if event == "CHAT_MSG_ADDON" and arg1 == "XY_START" and not IsLeader then
        DisableLeaderOperation()
    end
    --发送许愿
    if event == "CHAT_MSG_ADDON" and arg1 == "XY_SYNC_NEW" and IsLeader then
        syncXy()
    end
    --同步许愿
    if event == "CHAT_MSG_ADDON" and arg1 == "XY_SYNC" and not IsLeader then
        receiveXySync(arg2)
    end
    --加入团队的时候请求同步数据
    if event == "CHAT_MSG_SYSTEM" and arg1 == "你加入了一个团队。" then
        SendAddonMessage("XY_SYNC_NEW", "", "RAID")
    end
    --离开队伍后恢复团长功能
    if event == "CHAT_MSG_SYSTEM" and arg1 == "你已经离开了这个团队" then
        IsLeader = false
        EnableLeaderOperation()
    end
    --删除新增的事件，没有用，并且会造成消息互相同步 by无道暴君 20250217
	--20250219增加记录监控roll点功能
	if event == "CHAT_MSG_SYSTEM" and isRolling and rollEndTime > GetTime() then
		local pattern = "(.+)掷出(%d+)（(%d+)-(%d+)）"
        if (string.find(arg1, pattern)) then
			--1 32 无道暴君 100 1 100
			local _, _, player, roll, min_roll, max_roll = string.find(arg1, pattern)
			if min_roll=="1" and max_roll=="100" then
				local exis = false
				local n = getn(rollData)
				if n > 0 then
					for i = 1, n do
						if rollData[i]["name"] == player then
							exis=true
						end
					end
				end
				
				if not exis then
					local xyInfo = getXyInfo(player)
					local curInfo = {
						name = player,
						roll = roll,
						class = xyInfo["class"],
						xy = xyInfo["xy"],
						dkp = xyInfo["dkp"]
					}
					table.insert(rollData,curInfo)
					RollMonitor_UpdateList()
				end
			end
		end
    end
end

-- 处理系统消息，更新许愿信息
function XyTracker_OnSystemMessage()
    local values = {}
    for word in string.gmatch(arg1, "%S+") do
        table.insert(values, word)
    end
    
    -- 如果许愿未开始，直接返回
    if not XyInProgress then
        return
    end

    local val1 = values[1]
    
    -- 原有的许愿处理逻辑
    if val1 and string.lower(val1) == "xy" and getn(values) > 1 then
        local Xy = values[2]
        XyTracker_OnXy(arg2, Xy)
        XyTracker_UpdateList()
        syncXy()
    elseif val1 and string.lower(val1) == "txy" and getn(values) > 2 then
        local player = values[2]
        local Xy = values[3]
        XyTracker_OnXy(player, Xy)
        XyTracker_UpdateList()
        syncXy()
    elseif XyTrackerOptions.XyOnlyMode == 0 and arg1 and string.find(arg1, "|Hitem:") then
        local Xy = arg1
        XyTracker_OnXy(arg2, Xy)
        XyTracker_UpdateList()
        syncXy()
    end
end

function receiveXySync(msg)
    DisableLeaderOperation()
    --获取同步开始
    for n, x in string.gfind(msg, "n=(.+),x=(.+)") do
        Xys = x
        XyArray = {}
        XyTracker_UpdateList()
        return
    end
    for p, c, x, s in string.gfind(msg, "p=(.+),c=(.+),x=(.+),s=(.+)") do
        local info = {}
        info["name"] = p
        info["class"] = c
        if x == "---未许愿---" then
            info["xy"] = ""
        else
            info["xy"] = x
        end
        info["dkp"] = s
        table.insert(XyArray, info)
        XyTracker_UpdateList()
    end
end

function syncXy()
    local n = getn(XyArray)
    local msg = "";
    if n > 0 then
        msg = "n=" .. n .. ",x=" .. Xys
        SendAddonMessage("XY_SYNC", msg, "RAID")
        for i = 1, n do
            local info = XyArray[i]
            local player = info["name"]
            local xy = info["xy"] or "---未许愿---"
            local dkp = info["dkp"] or 4
            local class = info["class"] or "无"
            msg = "p=" .. player .. ",c=" .. class .. ",x=" .. xy .. ",s=" .. dkp
            SendAddonMessage("XY_SYNC", msg, "RAID")
        end
    end
end

function DisableLeaderOperation()
    --这个必须保留，避免团员在进团之前开过许愿 by 无道暴君 20250217
    XyInProgress = false
    getglobal("XyTrackerFrameStartButton"):Hide();
    getglobal("XyTrackerFrameStopButton"):Hide();
    getglobal("XyTrackerFrameResetButton"):Hide();
    getglobal("XyTrackerFrameAnnounceButton"):Hide();
    getglobal("XyTrackerFrameExportButton"):Hide();
    getglobal("XyTrackerFrameChuShiHua_DKP"):Hide();
    getglobal("XyTrackerFrameBatchAddFrame"):Hide();
end

function EnableLeaderOperation()
    XyInProgress = false
    getglobal("XyTrackerFrameStartButton"):Show();
    getglobal("XyTrackerFrameResetButton"):Show();
    getglobal("XyTrackerFrameAnnounceButton"):Show();
    getglobal("XyTrackerFrameExportButton"):Show();
    getglobal("XyTrackerFrameChuShiHua_DKP"):Show();
    getglobal("XyTrackerFrameBatchAddFrame"):Show();
end

function XyQuery(player, dkpnumber)
    local n = getn(XyArray)
    for i = 1, n do
        local name = XyArray[i]["name"]
        local xy = XyArray[i]["xy"]
        local currentDKP = XyArray[i]["dkp"] -- 直接使用存储的值，不做任何转换或限制
        
        if not xy then
            xy = ""
        end
        if player == name then
            if dkpnumber and dkpnumber ~= 0 then
                if dkpnumber > 0 then
                    SendChatMessage(player .. " 增加[" .. dkpnumber .. "]分,当前剩余分数：[" .. currentDKP .. "]", "RAID", this.language, nil);
                else
                    SendChatMessage(player .. " 扣除[" .. 0 - dkpnumber .. "]分,当前剩余分数：[" .. currentDKP .. "]", "RAID", this.language, nil);
                end
            else
                SendChatMessage(player .. " 许愿[" .. xy .. "],当前剩余分数：[" .. currentDKP .. "]", "RAID", this.language, nil);
            end
            break -- 找到玩家后就退出循环
        end
    end
end


function XyTracker_OnXy(name, Xy)
    local info = getXyInfo(name)
    info["xy"] = Xy
    -- 只有团长端会弹出界面
    if IsLeader then
    XyTracker_ShowXyWindow()
    end
    
    -- 新增：重复许愿检查
    if XyInProgress then
        local itemName = ExtractItemName(Xy)
        local count = 0
        for i = 1, getn(XyArray) do
            local currentXY = ExtractItemName(XyArray[i]["xy"] or "")
            if currentXY == itemName then
                count = count + 1
            end
        end
        if XyTrackerOptions.AutoAnnounce and count >= 2 then
            SendChatMessage("☆"..itemName.."☆已有 "..count.." 人许愿！", "RAID", this.language, nil)
        end
    end
end

function XyTracker_OnStartButtonClick()
    if GetNumRaidMembers() > 1 then
        IsLeader = true
		if XyTrackerOptions.XyOnlyMode == 1 then
			SendChatMessage("开始许愿，仅允许在团队频道输入【XY 许愿装备】可以被记录", "RAID", this.language, nil);
		else
			SendChatMessage("开始许愿，在团队频道输入【XY 许愿装备】或者直接贴装备链接可以被记录", "RAID", this.language, nil);
		end
        XyInProgress = true
        XyTracker_ShowXyWindow()
        --同步到团员端
        SendAddonMessage("XY_START", "", "RAID")
    end
end

function XyTracker_OnStopButtonClick()
    SendChatMessage("许愿结束，后续许愿无效", "RAID", this.language, nil)
    XyInProgress = false
end

function XyTracker_OnClearButtonClick()
    XyArray = {}
    XyItemCount = {}  -- 新增：清空物品计数
    local totalMembers = GetNumRaidMembers()
    if totalMembers then
        for i = 1, totalMembers do
            local name, rank, subgroup, level, class, fileName, zone, online = GetRaidRosterInfo(i);
            info = {}
            info["name"] = name
            info["class"] = class
            info["dkp"] = 4
            info["xy"] = "---未许愿---"
            table.insert(XyArray, info)
            NoXyList = NoXyList .. name .. " "
        end
    end
    XyTracker_UpdateList()
    if IsLeader then
        syncXy()
    end
end

function XyTracker_OnRefreshButtonClick()
    local totalMembers = GetNumRaidMembers()
    if totalMembers then
        local newXyArray = {}
        -- 创建一个临时表来存储现有的许愿信息
        local existingWishes = {}
        for i = 1, getn(XyArray) do
            local info = XyArray[i]
            existingWishes[info["name"]] = {
                xy = info["xy"],
                dkp = info["dkp"] or DefaultDKP  -- 修改这里，移除可能的最小值限制
            }
        end
        
        -- 重新构建团队成员列表，保留许愿信息
        for i = 1, totalMembers do
            local name, rank, subgroup, level, class = GetRaidRosterInfo(i)
            local info = {}
            info["name"] = name
            info["class"] = class
            
            -- 如果该玩家之前有许愿信息，则保留
            if existingWishes[name] then
                info["xy"] = existingWishes[name].xy
                info["dkp"] = existingWishes[name].dkp
            else
                info["xy"] = "---未许愿---"
                info["dkp"] = DefaultDKP or 4
            end
            
            table.insert(newXyArray, info)
        end
        
        XyArray = newXyArray
        if IsLeader then
            syncXy()
        end
    end
    XyTracker_UpdateList()
end

function XyTracker_OnAnnounceButtonClick()
    if NoXyList == "" then
        SendChatMessage("所有人都已经许愿", "RAID", this.language, nil);
    else
        SendChatMessage("以下人员未许愿，请尽快许愿：" .. NoXyList, "RAID", this.language, nil);
    end
end

function XyTracker_OnExportButtonClick()
    local n = getn(XyArray)
    local csvText = ""
    for i = 1, n do
        local xy = XyArray[i]["xy"]
        if not xy then
            xy = ""
        end
        csvText = csvText .. XyArray[i]["class"] .. "-" .. XyArray[i]["name"] .. "-" .. xy .. "-当前剩余:[" .. XyArray[i]["dkp"] .. "]分" .. "\n"
    end
    getglobal("XyExportEdit"):SetText(csvText);
    getglobal("XyExportFrame"):Show();
end

function Xy_FixZero(num)
    if (num < 10) then
        return "0" .. num;
    else
        return num;
    end
end

function Xy_Date()
    local t = date("*t");

    return strsub(t.year, 3) .. "-" .. Xy_FixZero(t.month) .. "-" .. Xy_FixZero(t.day) .. " " .. Xy_FixZero(t.hour) .. ":" .. Xy_FixZero(t.min) .. ":" .. Xy_FixZero(t.sec);
end

function XyAddDkp(player, score)
    if not player or not score then return end
    
    local info = getXyInfo(player)
    if info then
        info["dkp"] = tonumber(info["dkp"]) + score
        XyTracker_UpdateList()
        XyQuery(player, score)
        syncXy()
    end
end

-- 为指定玩家扣除DKP点数
function XyMinusDkp(player, score)
    if not player or not score then return end
    
    local info = getXyInfo(player)
    if info then
        info["dkp"] = tonumber(info["dkp"]) - score
        XyTracker_UpdateList()
        XyQuery(player, -score)
        syncXy()
    end
end
-- 设置DKP排序选项
function XySortOptions(method)

    if (Xy_SortOptions.method and Xy_SortOptions.method == method) then
        if (Xy_SortOptions.itemway and Xy_SortOptions.itemway == "asc") then
            Xy_SortOptions.itemway = "desc";
        else
            Xy_SortOptions.itemway = "asc";
        end
    else
        Xy_SortOptions.method = method;
        Xy_SortOptions.itemway = "asc";
    end
    Xy_SortDkp();
    XyTracker_UpdateList();
end

function Xy_SortDkp()
    table.sort(XyArray, Xy_CompareDkps);
end

function Xy_CompareDkps(a1, a2)
    local method, way = Xy_SortOptions["method"], Xy_SortOptions["itemway"];
    local c1, c2 = a1[method], a2[method];
    if (way == "asc") then
        return c1 < c2;
    else
        return c1 > c2;
    end
end

function ExtractItemName(xy)
    if string.find(xy, "|Hitem:") then
        return string.match(xy, "|h%[(.-)%]|h") or xy
    else
        return xy
    end
end

-- 合并 江湖任我行@乌龟服-拉&风 的修改
--加Atlas tooltip 提示许愿人数...
if AtlasLootTooltip then
    Xytooltip = CreateFrame("Frame", "Xytooltip", AtlasLootTooltip)
    Xytooltip:SetScript("OnShow", function(self)
        local Itemname = getglobal("AtlasLootTooltipTextLeft1"):GetText()
        local namelist
        if Itemname then 
        namelist = XYLIST1(Itemname)
        end
        --print(Itemname)
        --print(namelist)
        if namelist then
            AtlasLootTooltip:AddLine(namelist)
        end
        AtlasLootTooltip:Show()
    end)

    Xytooltip:SetScript("OnHide", function()
        AtlasLootTooltip:Hide()
    end)
end
--加物品 Gametooltip 提示许愿人数...
if GameTooltip then
    Xytooltip2 = CreateFrame("Frame", "Xytooltip2", GameTooltip)
    Xytooltip2:SetScript("OnShow", function(self)
        local Itemname = getglobal("GameTooltipTextLeft1"):GetText() or ""
        --Itemname = string.match(Itemname, " (.*)")
        --print(Itemname)
        local namelist
        if Itemname then 
        namelist = XYLIST1(Itemname) or XYLISTbyPlayer(Itemname)   --先当作物品名查询许愿,再当人名查询人名下的许愿.
        end
        
        if namelist then
            GameTooltip:AddLine(namelist)
        end
        GameTooltip:Show()
    end)

    Xytooltip2:SetScript("OnHide", function()
        GameTooltip:Hide()
    end)
end
--加点击物品 tooltip 提示许愿人数...
if ItemRefTooltip then
    Xytooltip3 = CreateFrame("Frame", "Xytooltip3", ItemRefTooltip)
    Xytooltip3:SetScript("OnShow", function(self)
        local Itemname = getglobal("ItemRefTooltipTextLeft1"):GetText()
        local namelist
        if Itemname then 
        namelist = XYLIST1(Itemname)
        end
        --print(Itemname)
        --print(namelist)
        if namelist then
            ItemRefTooltip:AddLine(namelist)
        end
        ItemRefTooltip:Show()
    end)

    Xytooltip3:SetScript("OnHide", function()
        ItemRefTooltip:Hide()
    end)
end

function ClasstoColor(class)
    if class =='战士' then return "|cffC79C6E"
    elseif  class =='萨满祭司' then return "|cff2773FF"
    elseif class =='德鲁伊' then return "|cffFF7D0A"
    elseif class =='盗贼' then return "|cffFFF569"
    elseif class =='法师' then return "|cff69CCFF"
    elseif class =='圣骑士' then return "|cffF58CBA"
    elseif class =='牧师' then return "|cffFFFFFF"
    elseif class =='术士' then return "|cff9482C9"
    elseif class =='猎人' then return "|cffABD473"
    end
  end
  
  
  function XYLIST(Iname)    
      --by qtz 非许愿模式下,贴装备,团队聊天窗口贴出许愿名单 ,返回许愿该装备的许愿名单.没有就返回nil   
      if XyArray ~=nil then
        local n = getn(XyArray)
        local i,name,xy,class,color
        local num = 0
        local itemname =""
        local XYID,NOW,xy_name
        --local itemtable = {}
              
        for i = 1, n do
          name = XyArray[i]["name"]
          xy = XyArray[i]["xy"] 
          if not xy then
            xy = ""
          end           
  
          --XYID,xy_name = string.match(xy, "item:(%d*):.-|h%[(.-)%]|h|r")
          xy_name = string.match(xy, "|h%[(.-)%]|h|r")          
          if xy_name then
            --if xy == arg1 or string.match(arg1, XYID) then 
            if xy_name == Iname then
              class = XyArray[i]["class"]
              color = ClasstoColor(XyArray[i]["class"]) 
              
              --itemname = itemname.. " ".. name..'-'..XyArray[i]["class"].."("..XyArray[i]["dkp"] .."分)"
              itemname = itemname.. " ".. color.. name.."|r("..XyArray[i]["dkp"] .."分)"
              NOW = xy_name
              num = num+1
            end
          end
        end
          --print(itemname)
        --if itemname ~="" and GetItemInfo(NOWID) and IsRaidOfficer() then
        if itemname ~="" and NOW then 
          --return "["..GetItemInfo(NOWID).."] ".."有:"..itemname.. ",共>"..num.."<人许愿."
          return "["..NOW.."]".. "|cffFFFF00("..num..")|r人许愿:"..itemname
          --SendChatMessage("["..GetItemInfo(NOWID).."] ".."有:"..itemname.. ",共>"..num.."<人许愿.", "SAY", this.language, nil);
          --SendChatMessage(xy_name.." 有:"..itemname.. ",共"..num.."人许愿.", "RAID", this.language, nil);
        else
          return nil
        end       
      end 
            -- qtz
  end
  
  function XYLIST1(Iname)    
      --by qtz tooltip提示许愿人数 ,返回许愿该装备的许愿名单.没有就返回nil   
      if XyArray ~=nil then
        local n = getn(XyArray)
        local i,name,xy,class,color
        local num = 0
        local p = 0
        local itemname = ""
        local XYID,NOW,xy_name
        --local itemtable = {}
              
        for i = 1, n do
          name = XyArray[i]["name"]
          xy = XyArray[i]["xy"] 
          if not xy then
            xy = ""
          end           
  
          --XYID,xy_name = string.match(xy, "item:(%d*):.-|h%[(.-)%]|h|r")
          xy_name = string.match(xy, "|h%[(.-)%]|h|r") or xy
            --print(xy_name)  
            
          if xy_name then
            --if xy == arg1 or string.match(arg1, XYID) then 
            if xy_name == Iname then
              num = num+1            
              class = XyArray[i]["class"]
              color = ClasstoColor(XyArray[i]["class"]) 
              if p == 3 then
                itemname = itemname.. "\n "..color..name .. "|r("..XyArray[i]["dkp"] .."分)"
                p=0
              else  
                itemname = itemname.. " "..color..name .. "|r("..XyArray[i]["dkp"] .."分)"
              end
              p = p+1
              NOW = xy_name            
            end
          end
        end
        --print(itemname)
        --if itemname ~="" and GetItemInfo(NOWID) and IsRaidOfficer() then
        if itemname ~="" and itemname then
          return "\n XY有:"..itemname.. "|cff9FFFA0".."\n  --共("..num..")人许愿--\n|r"
          --return "\n XY有:"..itemname.. ",\n  --共("..num..")人许愿--\n"          
        else
          return nil   
        end       
      end          
  end
  
  
  --通过玩家名字查询许愿和许愿人数
  
  local playername
  function XYLISTbyPlayer(playername)    
      --by qtz tooltip提示许愿人数 ,返回许愿该装备的许愿名单.没有就返回nil   
      if XyArray ~=nil then
        local n = getn(XyArray)
        local i,name,xy,class,color,dkp
        local num = 0
        local p = 0
        local itemname = ""
        local XYID,NOW,xy_name,playxy      
        local itemtable = {}
        playername = string.match(playername, " (%S+)") or string.match(playername, " ([^%s]+)") or playername
        
        for i = 1, n do
          name = XyArray[i]["name"]
          xy = XyArray[i]["xy"] 
          if name == playername then
            playxy = string.match(xy, "|h%[(.-)%]|h") or xy
            NOW = xy
            dkp = XyArray[i]["dkp"]
            break
          end
        end 
        for i = 1, n do
          name = XyArray[i]["name"]
          xy = XyArray[i]["xy"] 
          if not xy then
            xy = ""
          end           
          --XYID,xy_name = string.match(xy, "item:(%d*):.-|h%[(.-)%]|h|r")
          xy_name = string.match(xy, "|h%[(.-)%]|h|r") or xy
            --print(xy_name)            
          if xy_name then          
            if xy_name == playxy then
              num = num+1            
              class = XyArray[i]["class"]
              color = ClasstoColor(XyArray[i]["class"])
            end
            
            if not itemtable[xy_name] then
              itemtable[xy_name] = 1
            else
              itemtable[xy_name] = itemtable[xy_name] + 1
            end
            
          end
        end
        --print(playername)
        --if itemname ~="" and GetItemInfo(NOWID) and IsRaidOfficer() then
        if NOW and NOW ~="" then  
          return " XY:"..NOW.."("..dkp.."分)\n   |cff9FFFA0".."--("..num..")人许愿--|r"           
        else
          return nil 
        end       
      end          
  end
  